/*	Megamin2.C by Lionel Baboud
	The Casio Site: http://perso.wanadoo.fr/duobab/
	e-mail: roland.baboud@wanadoo.fr
	------------------------------
	this prog was compiled with Borland TurboC 2.01 and Tasm4.1
*/

#include <stdio.h>
#include <conio.h>
#include <dos.h>
#define sc1(a) putchar(0xF6);putchar(a)
#define sc2(a) putchar(0xF7);putchar(a)
#define CLR 28	/* PC:13	  CAS:28*/
#define PUT 83	/*	 59		 83*/
#define RET 28	/*	 13		 28*/
#define SEG 0x1A20

char pics[][5][5]=
	{	{{1,1,1,1,1}, /*plein*/
		{1,1,1,1,1},
		{1,1,1,1,1},
		{1,1,1,1,1},
		{1,1,1,1,1}},

		{{0,0,1,0,0}, /*1*/
		{0,0,1,0,0},
		{0,0,1,0,0},
		{0,0,1,0,0},
		{0,0,1,0,0}},

		{{1,1,1,1,1}, /*2*/
		{0,0,0,0,1},
		{1,1,1,1,1},
		{1,0,0,0,0},
		{1,1,1,1,1}},

		{{1,1,1,1,1}, /*3*/
		{0,0,0,0,1},
		{0,1,1,1,1},
		{0,0,0,0,1},
		{1,1,1,1,1}},

		{{0,0,1,0,0}, /*4*/
		{0,1,0,0,0},
		{1,0,0,1,0},
		{1,1,1,1,1},
		{0,0,0,1,0}},

		{{1,1,1,1,1}, /*5*/
		{1,0,0,0,0},
		{1,1,1,1,1},
		{0,0,0,0,1},
		{1,1,1,1,1}},

		{{1,1,1,1,1}, /*6*/
		{1,0,0,0,0},
		{1,1,1,1,1},
		{1,0,0,0,1},
		{1,1,1,1,1}},

		{{1,1,1,1,1}, /*7*/
		{0,0,0,0,1},
		{0,0,0,1,0},
		{0,0,1,0,0},
		{0,0,1,0,0}},

		{{1,1,1,1,1}, /*8*/
		{1,0,0,0,1},
		{1,1,1,1,1},
		{1,0,0,0,1},
		{1,1,1,1,1}},

		{{0,0,0,0,0}, /*vide*/
		{0,0,0,0,0},
		{0,0,0,0,0},
		{0,0,0,0,0},
		{0,0,0,0,0}},

		{{1,1,1,1,1}, /*flag*/
		{1,0,1,0,1},
		{1,1,0,1,1},
		{1,0,1,0,1},
		{1,1,1,1,1}},

		{{1,0,1,0,1}, /*mine*/
		{0,1,1,1,0},
		{1,1,1,1,1},
		{0,1,1,1,0},
		{1,0,1,0,1}},

		{{1,0,0,0,1}, /*bad flag*/
		{0,1,0,1,0},
		{0,0,1,0,0},
		{0,1,0,1,0},
		{1,0,0,0,1}}

	};

/*		{{0,0,1,0,0}, curseur
		{0,1,1,1,0},
		{1,1,0,1,1},
		{0,1,1,1,0},
		{0,0,1,0,0}},*/


int random(int p)
	{return  1+p*(double)rand()/32768;}

void setPix(unsigned short int x, unsigned short int y,unsigned int segm,char state)
	{asm push ax;
	asm push cx;
	asm push dx;
	asm mov cx,x;
	asm mov dx,y;
	asm mov es,segm;
	asm mov al,state;
	asm mov si,0x003f;
	asm sub si,dx;
	asm sub cx,0x80;
	asm not cx;
	asm push cx;
	asm and cl,0xf8;
	asm shl cx,0x03;
	asm add si,cx;
	asm pop cx;
	asm and cl,0x07;
	asm mov ah,0xfe;
	asm rol ah,cl;
	asm and es:[si],ah;
	asm mov ah,al;
	asm rol ah,cl;
	asm or es:[si],ah;
	asm pop dx;
	asm pop cx;
	asm pop ax;}

void invPix(unsigned short int x, unsigned short int y,unsigned int segm)
	{asm push ax;
	asm push cx;
	asm push dx;
	asm mov cx,x;
	asm mov dx,y;
	asm mov es,segm;
	asm mov si,0x003f;
	asm sub si,dx;
	asm sub cx,0x80;
	asm not cx;
	asm push cx;
	asm and cl,0xf8;
	asm shl cx,0x03;
	asm add si,cx;
	asm pop cx;
	asm and cl,0x07;
	asm mov ah,0xfe;
	asm rol ah,cl;
	asm mov al,1;
	asm rol al,cl;
	asm and al,es:[si];
	asm and es:[si],ah;
	asm not ah;
	asm xor ah,al;
	asm or es:[si],ah;
	asm pop dx;
	asm pop cx;
	asm pop ax;}

int trns(char i)
	{int v=i;
	if (i>=10 && i<20) v=0;
	if (i==0) v=9;
	if (i>=20) v=10;
	if (i==9) v=11;
	/*if (i==-1) v=12;*/
	if (i==-2) v=12;
	return v;}

void drawCase(int m,int n,int c)
	{int i,j,k;
	k=trns(c);
	for (i=0;i<5;i++)
		for (j=0;j<5;j++)
			setPix(6*n+j-4,6*m+i-4,SEG,pics[k][i][j]);}

void clrCase(int m,int n)
	{int i,j;
	for (i=-1;i<=5;i++)
		for (j=-1;j<=5;j++)
			setPix(6*n+j-4,6*m+i-4,SEG,0);}

void invCase(int m,int n)
	{int i,j;
	for (i=-1;i<=5;i++)
		for (j=-1;j<=5;j++)
			invPix(6*n+j-4,6*m+i-4,SEG);}

void hline(int x1,int x2,int y)
	{int i;
	for(i=x1;i<=x2;i++) setPix(i,y,SEG,1);}

void vline(int x,int y1,int y2)
	{int i;
	for(i=y1;i<=y2;i++) setPix(x,i,SEG,1);}

void rect(int x1,int y1,int x2,int y2)
	{hline(x1,x2,y1);
	hline(x1,x2,y2);
	vline(x1,y1,y2);
	vline(x2,y1,y2);}

void invRect(int x1,int y1,int x2,int y2)
	{int i,j;
	for(i=x1;i<=x2;i++)
		for(j=y1;j<=y2;j++)
			invPix(i,j,SEG);}

void drawCadre(x1,y1,x2,y2)
	{rect(x1,y1,x2,y2);
	hline(x1+1,x2+1,y2+1);
	vline(x2+1,y1+1,y2+1);}

void clrgfx()
	{asm push ax;
	asm mov ax,0x0000;
	asm	int 10h;
	asm pop ax;}

int waitkey()
	{int v=getch();
	if (v==0) v=getch();
	return v;}

char getSec() 
	{struct time temps;
	gettime(&temps);
	return temps.ti_sec;}

help()
	{clrscr();
	printf("Megamine - by Duobab\n\n");
	printf("[");sc1(0x9C);printf("][");sc1(0x9E);printf("][");sc1(0x9F);
	printf("][");sc1(0x9D);printf("]:move\n");
	printf("[EXE]:clear place\n");
	printf("[DEL]:put/remove flag");
	printf("[F1]:pause game\n");
	printf("[F6]:quit game");
	invRect(0,0,127,7);
	waitkey();}
	
main()
	{int key,m,n,i,j,p,q,c,d,t;
	int cx[210];int cy[210];
	int reste,lose,cases,mines,cheat,flags;
	int map[12][23];
	int incx[]={0,1,1,1,0,-1,-1,-1};
	int incy[]={-1,-1,0,1,1,1,0,-1};
	srand(time());
	p=0;q=0;mines=10;c=0;d=0;t=0;flags=0;

	debut:
	clrscr();
	printf("     Megamine 2\n");
	printf("      --------\n");
	printf("     by Duobab\n\n");
	printf("  number of mines:");
	gotoxy(1,8);printf("[F1]:keys");
	gotoxy(8,6);sc1(0xBB);
	invRect(0,0,127,7);
	drawCadre(10,30,116,48);

	key=0;
	while((key<48||key>57)&&key!=59) key=getch();
	if (key==59) {help();goto debut;}
	putchar(key);
	mines=key-48;
	key=-1;
	while((key<48||key>57)&&key!=RET&&key!=59)
		{key=getch();
		if (key==0) key=getch();}
	if (key==59) {help();goto debut;}
	if (key!=RET) mines=10*mines+(key-48);
	gotoxy(3,5);printf("    %2d mines     ",mines);
	gotoxy(3,6);
	if (mines<10) 				printf("   -very easy-");
	if (mines>=10 && mines<20)	printf("     -easy-");
	if (mines>=20 && mines<30) 	printf("    -normal-");
	if (mines>=30 && mines<50) 	printf("     -hard-");
	if (mines>=50 && mines<70) 	printf("   -very hard-");
	if (mines>=70) 			printf("   -kamikase!-");
	while(!kbhit())
		{c=getSec()%2;
		gotoxy(1,8);
		printf((c==0?"  -[ press a key ]-":"                   "));}
	waitkey();

	replay:
	m=5;n=11;
	reste=-1;lose=0;cases=210;flags=0;
	cheat=0;
	for(i=0;i<12;i++)
		for(j=0;j<23;j++)
			map[i][j]=((i==0||j==0||i==11||j==22)?40:10);
	for (j=0;j<mines;j++)
		{int g,h;
		do {g=random(10);h=random(21);} while(map[g][h]==19);
		map[g][h]=19;
		for (i=0;i<8;i++)
			{int a=g+incx[i];int b=h+incy[i];
			if (map[a][b]<19) map[a][b]++;}
		}
	key=0;
	for (i=0;i<210;i++) {cx[i]=0;cy[i]=0;}

	clrgfx();
	for(i=1;i<=10;i++)
		for(j=1;j<=21;j++)
			drawCase(i,j,10);
	/*drawCase(m,n,-1);*/

	while (key!=64 && lose!=1 && !(cases==mines))
		{/*d=-1;*/
		drawCase(m,n,map[m][n]);
		t=0;invCase(m,n);
		while(!kbhit())
			{c=getSec()%2;
			if (t<1 && c!=d) {t++;d=c;}
			if (t==1 && c!=d) {invCase(m,n);d=c;}}
		clrCase(m,n);
		key=getch();if (key==0) key=getch();
		p=m;q=n;
		if (key==72) m--;
		if (key==77) n++;
		if (key==80) m++;
		if (key==75) n--;
		if (m==0) m=10;if (m==11) m=1;
		if (n==0) n=21; if (n==22) n=1;

		if (key==59)
			{for(i=28;i<=92;i++) for(j=13;j<=42;j++) setPix(i,j,SEG,0);
			drawCadre(29,14,90,40); /*+-5*/
			gotoxy(7,4);printf("mines:%2d",mines);
			gotoxy(7,5);printf("flags:%2d",flags);
			d=1;
			while(!kbhit())
				{c=getSec()%2;gotoxy(7,3);
				if (c==0 && d==1) {printf("-PAUSED-");d=0;}
				if (c==1 && d==0) {printf("        ");d=1;}}
			waitkey();
			for(i=26;i<=96;i++) for(j=13;j<=42;j++) setPix(i,j,SEG,0);
			for(i=3;i<8;i++) for(j=5;j<=16;j++) drawCase(i,j,map[i][j]);}

		drawCase(p,q,map[p][q]);

		if (key==65) cheat=1;
		if (key==66 && cheat==1) cheat=2;
		if (key==67 && cheat==2) cheat=3;
		if (key==68) {cheat=0;drawCase(1,21,map[1][21]);}
		if (cheat==3) {drawCase(1,21,map[m][n]%10);}

		if (key==CLR && map[m][n]>=10 && map[m][n]<20)
			{map[m][n]-=10;cases--;
			if (map[m][n]==9) {lose=1;cases++;}
			if (map[m][n]==0)
				{reste=0;
				cx[0]=m;cy[0]=n;
				while (reste!=-1)
					{int a=cx[reste];int b=cy[reste];
					reste--;
					for (i=0;i<8;i++)
						{int e=a+incx[i];int f=b+incy[i];
						if (map[e][f]>=10 && map[e][f]<30)
							{if (map[e][f]>=20) {map[e][f]-=10;flags--;}
							map[e][f]-=10;
							cases--;
							if (map[e][f]==0) {reste++;cx[reste]=e;cy[reste]=f;}
							drawCase(e,f,map[e][f]);}
						}
					}
				}

			}
		if (key==PUT)
			{if (map[m][n]>=10 && map[m][n]<20) {map[m][n]+=10;flags++;}
			else if (map[m][n]>=20 && map[m][n]<30) {map[m][n]-=10;flags--;}}
		/*drawCase(m,n,-1);*/
		}

	if (lose==1)
		{for(i=1;i<=10;i++)
			for(j=1;j<=21;j++)
				{if (map[i][j]==19 || map[i][j]==9) drawCase(i,j,9);
				if(map[i][j]>=20 && map[i][j]<29) drawCase(i,j,-2);}
		i=getch();if(i==0) getch();}

	clrgfx();
	if (lose==1) 	{printf("You've lost!\n");
				printf("Begin with less mines");}
	if (cases==mines) {	printf("Well done!\n");
					printf("Try with more mines");}
	if (key==64) printf("Do you give up?\n");
	gotoxy(1,4);
	printf("[EXE]:retry\n");
	printf("[F1]:new game\n");
	printf("[F2]:keys\n");
	printf("[F6]:exit\n");

	key=waitkey();
	if (key==RET) goto replay;
	if (key==59) goto debut;
	if (key==60) {help();goto debut;}

	clrscr();
	printf("Megamine2 by Duobab\n");
	printf("--------           \n");
	printf("The Casio site:    \n");
	printf(" |http://          \n");
	printf(" |perso.wanadoo.fr \n");
	printf(" |/duobab/         \n\n");
	printf("Salut..");
	invRect(0,14,108,48);
	waitkey();
	}
